import java.io.IOException;

import jj2000.j2k.image.DataBlkInt;
import jj2000.j2k.image.ImageStatsCalculator;

import jj2000.j2k.image.input.ImgReaderPGM;

/*
 * Created on Jun 2, 2006
 *
 */

public class BitPlaneDecomposition {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		String fname = args[0];
		System.out.println("Generating Bitplane PBMs for " + fname );
		String bname = fname.substring(0,fname.length() - 4);
    	try
		{
    		ImgReaderPGM reader = new ImgReaderPGM(fname);
    		DataBlkInt blk =  ImageStatsCalculator.getDataBlkInt(reader,0);
    		//System.out.println (sobel.imageAngle(blk, 80));
    		int data[] = blk.getDataInt();

    		for (int p = 0; p < 8; p++)
    		{
    			int mask = (1 << p);
        		int bit_data [] = new int[data.length]; 
    			System.out.println (Integer.toBinaryString(mask));
    			for (int i = 0; i < data.length; i++)
    			{
    				int coeff = data[i];
    				bit_data[i] = (mask & coeff) != 0 ? 1 : 0;    				
    			}
        		DataBlkInt bit_blk = new DataBlkInt(0,0, reader.getImgWidth(), reader.getImgHeight());
        		bit_blk.setData(bit_data);
    			ImageStatsCalculator.writePBM(bit_blk, bname + "-" + p + ".pbm");
    		}
    			
		}
    	catch (IOException e)
		{
    		System.out.println("ERROR");
		}


	}

}

