import java.io.IOException;

import jj2000.j2k.image.BlkImgDataSrc;
import jj2000.j2k.image.DataBlkInt;
import jj2000.j2k.image.ImageStatsCalculator;
import jj2000.j2k.image.input.ImgReaderPGM;
import jj2000.j2k.util.ArrayUtil;
import jj2000.j2k.wavelet.QTDM;
import jj2000.j2k.wavelet.SubbandStructure;
import jj2000.j2k.wavelet.WPRandomStructureGenerator;

/*
 * Created on Jun 13, 2006
 * Recreated on Oct 02, 2006
 */

public class QTDMCompression {

	public static void usage ()
	{
		System.out.println ("Usage: QTDMCompression img_file rand_spec_1 rand_spec_2 GPFile lin|res|lev");
		System.exit(1);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {


		if (args.length != 5)
		{
			usage();
		}
		String iname = args[0];
		String spec1 = args[1];
		String spec2 = args[2];
		String fname = args[3];
		String sfunc = args[4];
		ImgReaderPGM reader = null;
		try {
			reader = new ImgReaderPGM(iname);		
		} catch (IOException e) {
			System.err.println ("Could not open " + iname + " for reading.");
			System.exit(1);
		}
		WPRandomStructureGenerator gen1 = new WPRandomStructureGenerator(spec1, reader);
		WPRandomStructureGenerator gen2 = new WPRandomStructureGenerator(spec2, reader);
		//WPUniformGenerator gen2 = new WPUniformGenerator(spec2);		
		SubbandStructure sbbs1 = gen1.createRandomStructure();
		SubbandStructure sbbs2 = gen2.createRandomStructure();
		System.out.println (ArrayUtil.printBitArrayAsHex(sbbs1.toBitPattern()));
		System.out.println (ArrayUtil.printBitArrayAsHex(sbbs2.toBitPattern()));
		sbbs1.plotTreeStructure("tree1.eps", 512, 512);
		sbbs2.plotTreeStructure("tree2.eps", 512, 512);
		System.out.println("Comparing common leaves");
		double val = QTDM.compareCommonLeaves(sbbs1, sbbs2, Math.max(sbbs1.resLvl, sbbs2.resLvl), sfunc);
		System.out.println ("\tDistance is: " + val);		
		ImageStatsCalculator.GPwriteResult(fname, val, false);		
	}

}
