import java.io.IOException;

import jj2000.j2k.image.input.ImgReaderPGM;
import jj2000.j2k.util.ArrayUtil;
import jj2000.j2k.wavelet.QTDM;
import jj2000.j2k.wavelet.SubbandStructure;
import jj2000.j2k.wavelet.WPUniformGenerator;

/*
 * Created on Jun 13, 2006
 *
 */

public class QTMDUniformTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {

		ImgReaderPGM reader = new ImgReaderPGM("lena512.pgm");
		
		WPUniformGenerator gen1 = new WPUniformGenerator("g5st", reader);
		WPUniformGenerator gen2 = new WPUniformGenerator("g5st", reader);
		
		SubbandStructure sbbs1 = gen1.createRandomStructure();
		SubbandStructure sbbs2 = gen2.createRandomStructure();
		
		System.out.println (ArrayUtil.printBitArrayAsHex(sbbs1.toBitPattern()));
		System.out.println (ArrayUtil.printBitArrayAsHex(sbbs2.toBitPattern()));
		sbbs1.plotTreeStructure("tree1.eps", 512, 512);
		sbbs2.plotTreeStructure("tree2.eps", 512, 512);		
		System.out.println("Comparing common leaves");
		double val = QTDM.compareCommonLeaves(sbbs1, sbbs2, Math.max(sbbs1.resLvl, sbbs2.resLvl), "lin");
		System.out.println ("\tDistance is: " + val);
		
		
	}

}
