import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import jj2000.j2k.util.FacilityManager;
import jj2000.j2k.util.MsgLogger;

/*
 * Created on Apr 14, 2008
 *
 */

public class SpliceCoeffFiles {
	
	public static void main (String args[]) {
		String fn1 = args[0];
		String fn2 = args[1];
		System.out.println ("Splicing: " + fn1 + " with " + fn2 );
		
		float [] coeffs1 =  new float [512*512];
		float [] coeffs2 =  new float [512*512];
		float [] coeffs = new float[512*512];
		try {
			FacilityManager.getMsgLogger().printmsg(
					MsgLogger.INFO,
					"Reading Coefficients from \"" + fn1 + "\"");
			FileInputStream fis = new FileInputStream(fn1);
			DataInputStream ins = new DataInputStream(fis);			
			int i = 0;
			while (ins.available() != 0)
			{																				
				coeffs1[i++] = ins.readFloat();
			}
			ins.close();
			fis.close();
			

			FacilityManager.getMsgLogger().printmsg(
					MsgLogger.INFO,
					"Reading Coefficients from \"" + fn2 + "\"");

			fis = new FileInputStream(fn2);
			ins = new DataInputStream(fis);
			i = 0;
			while (ins.available() != 0)
			{																				
				coeffs2[i++] = ins.readFloat();
			}			
			ins.close();
			fis.close();
			
		} catch (Exception e) {
			System.err.println ("Error: " + e.toString());
			e.printStackTrace();
		}
		
		//Splice now:		
		for (int y = 0; y < 512; y++)
			for (int x = 0; x < 512; x++) {
				if (x < 256 && y < 256)
					coeffs[y*512 + x ]  = coeffs1[y*512+x];
				else
					coeffs[y*512 + x ]  = coeffs2[y*512+x];				       
			}
		
		//Write to file
		try {
    		String fname = "spliced.coeff";
    		FacilityManager.getMsgLogger().printmsg(
					MsgLogger.INFO, "Writing Coefficients to \"" + fname + "\"");
			FileOutputStream fos = new FileOutputStream(fname, false);
			DataOutputStream out = new DataOutputStream(fos);
    		
			for (int i = 0; i < coeffs.length; i++)
			{
				out.writeFloat(coeffs[i]);
			}

    		
    	} catch (Exception e) {
    		FacilityManager.getMsgLogger().printmsg(MsgLogger.ERROR,
					e.toString());
    	}
		
	
	}

}
