package jj2000.j2k.encryption;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Vector;

import jj2000.j2k.codestream.reader.CBlkInfo.InclusionInfo;

public class HeaderHashFileReader {
	
	private Vector<Integer> iInfo;
	private Vector<Integer> msbs;
	private Vector<Integer> lengths;
	private Vector<Integer> ncps;
	
	BufferedReader in;
	
	public void read (String fname) {
		try {			
			in = new BufferedReader(new FileReader(fname));
			/*printInclusionVector() + "\n" +
			printMSBVector() + "\n" + 
			printLengthsVector() + "\n" +
			printNCPVector()*/
			iInfo = readVector();
			msbs = readVector();
			lengths = readVector();
			ncps = readVector();
		}
		catch (FileNotFoundException fnfe) {
			System.err.println (fnfe.toString());
			System.exit (1);
		}
		catch (IOException ioe) {
			System.err.println (ioe.toString());
			System.exit (1);			
		}
	}
	
	private Vector<Integer> readVector() throws IOException {
		Vector<Integer> res = new Vector<Integer>();
		String line = in.readLine();
		String elements[] = line.split(":");
		for (int i = 0; i < elements.length; i++) {
			res.add(Integer.parseInt(elements[i]));
		}
		return res;
	}
	
	public Vector<Integer>getInclusionVector() {
		return iInfo;
	}
	
	public Vector<Integer>getMSBVector() {
		return msbs;
	}

	public Vector<Integer>getLengthsVector() {
		return lengths;
	}

	public Vector<Integer>getNCPVector() {
		return ncps;
	}	
	
	public Vector<Vector<Integer>> getAllHashes () {
		Vector<Vector<Integer>> vec = new Vector<Vector<Integer>>();
		vec.add (getInclusionVector());
		vec.add (getMSBVector());
		vec.add (getLengthsVector());
		vec.add (getNCPVector());
		return vec;
	}
}
