package jj2000.j2k.encryption;

import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import jj2000.j2k.util.FacilityManager;
import jj2000.j2k.util.MsgLogger;

public class HeaderHashFileWriter {
	
	
	public void writeHashes (Vector<Vector<Integer>> hashVecs, String fname) {
		try
		{
			
			FileOutputStream fos = new FileOutputStream (fname, false);
			DataOutputStream out = new DataOutputStream(fos);
			//if (res < 0) res = 0;
			//if (Double.isNaN(res)) res = 0;
			Iterator<Vector<Integer>> hit = hashVecs.iterator();
			while (hit.hasNext()) {
				out.writeBytes(printVec(hit.next()) + "\n");				
			}
		
			out.close();
		}
		catch (FileNotFoundException fnfe) {
			FacilityManager.getMsgLogger().printmsg(MsgLogger.ERROR, "File not Found");
		}
		catch (IOException ioe) {			
			FacilityManager.getMsgLogger().printmsg(MsgLogger.ERROR, "IO Error");	
		}
		finally
		{
			FacilityManager.getMsgLogger().printmsg(MsgLogger.INFO, "Header Hash written to " + fname);	
		
		}

	}
	
	public String printVec(Vector<Integer> hashVec) {
		String rtn = "";
		
		Iterator<Integer> it = hashVec.iterator();
		while (it.hasNext()) {
			rtn += it.next() + ":";
		}
		
		return rtn.substring(0, rtn.length()-1);
	}
}
